#include "Gui.h"

Gui::Gui() :
        menu(),
        menu_items0("Test-submenu - 1"),
        menu_items1("Test-submenu - 2"),
        menu_items2("Test-submenu - 3"),
        root_menu("Root Menu"),
        vbox(),
        menu_bar(),
        event_box(),
        label("press me")
{

    // Sets the border width of the window.
    set_border_width(10);
    set_default_size(200, 200);

    /* Init the menu-widget, and remember -- never
       * gtk_show_widget() the menu widget!!
       * This is the menu that holds the menu items, the one that
       * will pop up when you click on the "Root Menu" in the app */

    //menu = gtk_menu_new ();

    /* Next we make a little loop that makes three menu-entries for "test-menu".
     * Notice the call to gtk_menu_append.  Here we are adding a list of
     * menu items to our menu.  Normally, we'd also catch the "clicked"
     * signal on each of the menu items and setup a callback for it,
     * but it's omitted here to save space. */

#if 0
    for (i = 0; i < 3; i++)
    {
        /* Copy the names to the buf. */

        //sprintf (buf, "Test-undermenu - %d", i);

        /* Create a new menu-item with a name... */

        //menu_items = gtk_menu_item_new_with_label (buf);

        /* ...and add it to the menu. */

        //gtk_menu_append (GTK_MENU (menu), menu_items);

        /* Do something interesting when the menuitem is selected */
        //gtk_signal_connect_object (GTK_OBJECT (menu_items), "activate",
        //    GTK_SIGNAL_FUNC (menuitem_response), (gpointer) g_strdup (buf));

        /* Show the widget */

        //gtk_widget_show (menu_items);
    }
#endif

    menu.append(menu_items0);
    menu_items0.show ();
    menu_items0.signal_activate().connect(
        sigc::bind<Glib::ustring> (
            sigc::mem_fun(*this, &Gui::menuitem_response),
            menu_items0.get_label() ) );

    menu.append(menu_items1);
    menu_items1.show ();
    menu_items1.signal_activate().connect(
        sigc::bind<Glib::ustring> (
            sigc::mem_fun(*this, &Gui::menuitem_response),
            menu_items1.get_label() ) );

    menu.append(menu_items2);
    menu_items2.show ();
    menu_items2.signal_activate().connect(
        sigc::bind<Glib::ustring> (
            sigc::mem_fun(*this, &Gui::menuitem_response),
            menu_items2.get_label() ) );

    /* This is the root menu, and will be the label
     * displayed on the menu bar.  There won't be a signal handler attached,
     * as it only pops up the rest of the menu when pressed. */

    //root_menu = gtk_menu_item_new_with_label ("Root Menu");

    //gtk_widget_show (root_menu);
    root_menu.show();

    /* Now we specify that we want our newly created "menu" to be the menu
     * for the "root menu" */

    //gtk_menu_item_set_submenu (GTK_MENU_ITEM (root_menu), menu);
    root_menu.set_submenu(menu);

    /* A vbox to put a menu and a button in: */

    //vbox = gtk_vbox_new (FALSE, 0);
    //gtk_container_add (GTK_CONTAINER (window), vbox);
    //gtk_widget_show (vbox);

    add(vbox);
    vbox.show();

    /* Create a menu-bar to hold the menus and add it to our main window */

    //menu_bar = gtk_menu_bar_new ();
    //gtk_box_pack_start (GTK_BOX (vbox), menu_bar, FALSE, FALSE, 2);
    //gtk_widget_show (menu_bar);

    vbox.pack_start(menu_bar,Gtk::PACK_SHRINK);
    menu_bar.show();

    /* Create a button to which to attach menu as a popup */

    //button = gtk_button_new_with_label ("press me");
    //gtk_signal_connect_object (GTK_OBJECT (button), "event",
    //    GTK_SIGNAL_FUNC (button_press), GTK_OBJECT (menu));
    //gtk_box_pack_end (GTK_BOX (vbox), button, TRUE, TRUE, 2);
    //gtk_widget_show (button);

    //NOTE: label used instead of button because eventboxes
    //      don't work with buttons
    event_box.add(label);
    event_box.add_events(Gdk::BUTTON_PRESS_MASK);
    event_box.signal_button_press_event().connect(
        sigc::mem_fun(*this, &Gui::button_press));
    event_box.set_tooltip_text("Click me!");
    event_box.show();

    vbox.pack_end(event_box,Gtk::PACK_SHRINK);

    label.show();

    /* And finally we append the menu-item to the menu-bar -- this is the
     * "root" menu-item I have been raving about =) */

    //gtk_menu_bar_append (GTK_MENU_BAR (menu_bar), root_menu);
    menu_bar.append(root_menu);

}

Gui::~Gui()
{
    root_menu.remove_submenu();
}

bool Gui::button_press(GdkEventButton* event)
{
    if (event->type == GDK_BUTTON_PRESS) {
        //GdkEventButton *bevent = (GdkEventButton *) event;

        //gtk_menu_popup (GTK_MENU (widget), NULL, NULL, NULL, NULL,
        //                bevent->button, bevent->time);
        menu.popup(event->button, event->time);
        /* Tell calling code that we have handled this event; the buck
         * stops here. */
        return true;
    }

    /* Tell calling code that we have not handled this event; pass it on. */
    return false;
}

void Gui::menuitem_response(Glib::ustring string)
{
    std::cout << string << std::endl;
}


